=== debian/changelog ===
freeorion (0.4.10~rc0-0ubuntu3) groovy; urgency=medium

  * No-change rebuild against libboost-regex1.71.0-icu67

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 28 Jul 2020 19:19:33 +0000

freeorion (0.4.10~rc0-0ubuntu2) groovy; urgency=medium

  * No change rebuild against new icu ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Jul 2020 16:41:21 +0100

freeorion (0.4.10~rc0-0ubuntu1) groovy; urgency=medium

  * New upstream release. Snapshot of v0.4.10 branch.
  * Switch to python3 & boost1.71

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Jun 2020 11:41:41 +0100

freeorion (0.4.9-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - use python2 & boost1.67

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Jun 2020 11:23:50 +0100

freeorion (0.4.8-3ubuntu5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:51:32 +0100

freeorion (0.4.8-3ubuntu4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:21:00 +0100

freeorion (0.4.8-3ubuntu3) focal; urgency=medium

  * Use boost1.67 for boost-python2.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 17 Feb 2020 20:03:52 +0000

freeorion (0.4.8-3ubuntu2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 10 Feb 2020 08:22:52 +0100

freeorion (0.4.8-3ubuntu1) focal; urgency=medium

  * Build-depend on python2.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Jan 2020 15:38:58 +0100

freeorion (0.4.8-3build1) focal; urgency=medium

  * No-change rebuild to generate dependencies on python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Dec 2019 12:33:22 +0000
