## freeorion 0.4.10

=== debian/changelog ===
freeorion (0.4.10-1~mx17+1) mx; urgency=medium

  * Rebuild for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 02 Oct 2020 20:58:52 -0700

freeorion (0.4.10-1~mx19+1) mx; urgency=medium

  * Rebuild for MX-19.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Fri, 02 Oct 2020 20:00:35 -0700

freeorion (0.4.10-1) unstable; urgency=medium

  * New upstream version 0.4.10.

 -- Markus Koschany <apo@debian.org>  Fri, 31 Jul 2020 13:33:50 +0200

freeorion (0.4.10~RC1-1) unstable; urgency=medium

  * New upstream version 0.4.10~RC1.
    - Support Python 3 now. (Closes: #936557)
  * Switch to debhelper-compat = 13.

 -- Markus Koschany <apo@debian.org>  Wed, 22 Jul 2020 22:46:38 +0200
