=== debian/control ===
--- 
+++ 
@@ -1,29 +1,27 @@
 Source: freeorion
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
 XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders:
- Markus Koschany <apo@debian.org>
-Build-Depends:
- cmake,
- debhelper-compat (= 12),
- dh-python,
- libalut-dev,
- libboost-all-dev,
- libfreetype6-dev,
- libgl1-mesa-dev,
- libglew-dev,
- libglu1-mesa-dev,
- libjpeg-dev,
- libogg-dev,
- libopenal-dev,
- libpng-dev,
- libsdl2-dev,
- libtiff-dev,
- libvorbis-dev,
- pkg-config,
- python3
+Uploaders: Markus Koschany <apo@debian.org>
+Build-Depends: cmake,
+               debhelper-compat (= 12),
+               dh-python,
+               libalut-dev,
+               libboost-all-dev,
+               libfreetype6-dev,
+               libgl1-mesa-dev,
+               libglew-dev,
+               libglu1-mesa-dev,
+               libjpeg-dev,
+               libogg-dev,
+               libopenal-dev,
+               libpng-dev,
+               libsdl2-dev,
+               libtiff-dev,
+               libvorbis-dev,
+               pkg-config,
+               python3
 Standards-Version: 4.5.0
 Homepage: http://www.freeorion.org
 Vcs-Git: https://salsa.debian.org/games-team/freeorion.git
@@ -31,10 +29,9 @@
 
 Package: freeorion
 Architecture: linux-any
-Depends:
- freeorion-data (= ${source:Version}),
- ${misc:Depends},
- ${shlibs:Depends}
+Depends: freeorion-data (= ${source:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: turn-based space empire and galactic conquest game
  FreeOrion is a turn-based space empire and galactic conquest (4X) game being
  designed and built by the FreeOrion project. FreeOrion is inspired by the
@@ -50,13 +47,11 @@
 
 Package: freeorion-data
 Architecture: all
-Depends:
- fonts-dejavu,
- fonts-roboto-unhinted,
- ${misc:Depends},
- ${python3:Depends}
-Suggests:
- freeorion
+Depends: fonts-dejavu,
+         fonts-roboto-unhinted,
+         ${misc:Depends},
+         ${python3:Depends}
+Suggests: freeorion
 Description: turn-based space empire and galactic conquest game -- data
  FreeOrion is a turn-based space empire and galactic conquest (4X) game being
  designed and built by the FreeOrion project.
