## freeorion 0.4.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,7 @@
 include(UseCodeCoverage)
 include(TargetDependencies)
 
-set(FreeOrion_VERSION 0.4.10)
+set(FreeOrion_VERSION 0.4.10.1)
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
