=== debian/changelog ===
freeorion (0.4.10.1-1) unstable; urgency=medium

  * New upstream version 0.4.10.1.

 -- Markus Koschany <apo@debian.org>  Sun, 11 Oct 2020 15:44:38 +0200
