=== debian/rules ===
--- 
+++ 
@@ -49,5 +49,6 @@
 	dh_python3 -pfreeorion-data /usr/share/games
 
 get-orig-source:
-	wget https://codeload.github.com/freeorion/freeorion/tar.gz/4428a2ce7bb7cb42f3eae8f7ab0d99a9eed9247f
+	wget https://github.com/freeorion/freeorion/releases/download/v0.4.10.1/FreeOrion_v0.4.10.1_2020-09-25.39cfe10_Source.tar.gz
 
+
